


XMRED(6)                 GAMES AND DEMOS         20 December 1993



NAME
     xmred - garden editor for xmris

SYNOPSIS
     xmred [-option ...] [-toolkitoption ...]

DESCRIPTION
     Xmred is a tool for creating and editing  alternate  gardens
     for xmris.  Hopefully its user interface is intuitive enough
     that most of this manual page need not be read by  a  casual
     user.

     In the default configuration, the  main  window  presents  a
     garden image on the left, a control panel on the right and a
     list of gardens underneath. Gardens can be loaded and  saved
     using  the  menu,  these then appear in the list below.  The
     insert option loads a file into the copy buffer. It can then
     be dragged to the desired place in the garden list.

     To edit a garden (or comment, or include), either select  it
     with  a  button  press  and release, or with a drag and drop
     into the edit box at the lower right. The drag and drop will
     remove  it from the garden list, selection will copy it, and
     the source garden will be updated too.  To  delete  gardens,
     drag  them to the copy buffer.  The main garden display will
     be updated, if it was a garden being moved to the edit  box.
     The  box  on  the lower right is a copy buffer. You can drag
     and drop into and out of this to the garden list or  one  of
     the  edit  boxes.  Similarly  you can drag and drop from the
     edit boxes to the garden list, and within  the  garden  list
     itself.  Note  that drag and drop always removes the source,
     if it is within the garden list, whereas selection does  not
     delete the source.

     The control panel shows a set of options, which can be bound
     to  buttons.  This  can  be done either by press and release
     with the required button, or drag and drop onto the required
     button's  icon. You can bind an option to more than one but-
     ton. However, press and release on the  apples  option  will
     simply  change  the  currently  selected explicit apple, not
     necessarily bind that option to a new button. The fill  pat-
     tern  and  color  can  be  select  by  pressing on them. The
     current garden will be updated. The list  of  buttons  shows
     which  options  are  bound  to  which  buttons. You can also
     change button bindings by pressing  the  destination  button
     with  the pointer over the button with the required option's
     icon, or by drag and drop from button to button.

     The six options are,

     Apple
          This selects where apples from one of the four sets  of



X Version 11                                                    1






XMRED(6)                 GAMES AND DEMOS         20 December 1993



          explicit  apple  locations  are placed. To select which
          set is being controlled, press on the relevant quadrant
          of  the  icon.  One of these sets is used when xmris is
          used with the +random option. You can place apples any-
          where there isn't a path, even in an unstable location,
          which will immediately fall. Placing an explicit  apple
          on a path, will fill the path.

     Random
          This controls where apples may be placed  randomly,  if
          xmris  is  started with the -random option. Apples will
          only be placed on the  specified  locations,  or  where
          ever  an  explicit  apple  could be located. Unless you
          specify otherwise, random apples may  be  located  any-
          where there isn't a path, even unstable locations which
          will immediately fall. Placing  a  random  apple  on  a
          path, will fill the path.

     Cherry
          This controls where cherries are located. There must be
          at  least  one  cherry  on  a  garden.  Cherries may be
          located anywhere on the board.

     Path This controls where the initial path is. Each  location
          on  the  board  consists  of  a  centre and four edges.
          Depending on the exact location  of  the  pointer,  you
          will  select  either  the centre, or an edge. Filling a
          path will place a random apple in the filled  location.
          The four locations immediately below the

     Player
          This controls where the player starts from. There  must
          be exactly one such location.

     Den  This controls where the monsters start from. There must
          be at least one den.

     The list of totals show the counts for the explicit  apples,
     cherries,  random  apples  required,  apple spaces, unstable
     apple positions, dens and player  positions.  A  warning  is
     shown  on  the left of any which are inconsistant, or out of
     range. The number of apples for a garden can be set by  mov-
     ing  the scroll bar at the left of the apple icon. Note that
     when you change the number  of  apples,  or  add  or  remove
     explicit  apples, a warning will change on on some or all of
     the explicit apple counts. This is just to remind  you  that
     you  must do some more work on the garden, before it is con-
     sistant. There are two types of random apple spaces,  stable
     and  unstable.  The  unstable  space  count is shown with an
     arrow in it, the other apple space  count  shows  the  total
     number  of apple spaces. The hazzard warning on the unstable
     count,  just  shows  that  you  have  some  unstable   apple



X Version 11                                                    2






XMRED(6)                 GAMES AND DEMOS         20 December 1993



     positions  (this  may be intentional on your part). The haz-
     zard on the total apple space count indicates that there are
     less  spaces than the number of apples you specified for the
     garden.

     Below this is a comment box for the garden.  Selecting  this
     will  pop  up a dialog which you can enter information about
     the garden.

     At the lower right of the control panel is  a  display  mode
     selector. There are three display modes. The first shows all
     the explicit apple positions, 4 to a cell when required. The
     second  shows  only  one  set  of  explicit  apples, the set
     selected using the apples option quadrant.  The  final  mode
     shows  none  of  the  explicit apples, just the random apple
     spaces.

     The garden display is on the left  of  this.  It  shows  the
     currently edited garden. Clicking or dragging a mouse button
     on this area will perform the option currently bound to that
     button. You will notice the totals change when you do this.

     Xmred will use colour sprites, if the visual permits it (has
     a  colour  map  size of more than 15, and you haven't forced
     monochrome). All the colours bar black and  white  are  user
     definable.  There  are  four  sets, one for each of the four
     combinations of gender and swap flag. The colours are  allo-
     cated  in  reverse  order of their distance in colour space,
     from currently allocated colours (the most  distant  colours
     are  allocated first). That way, if allocation fails because
     the colour map is  full,  an  allocated  substitute  colour,
     which  is  nearest  the  desired colour, can be used and the
     allocated colours are kept maximally distant.  You can limit
     the number of distinct colours with the -distinct option.  A
     warning message is sent to stderr, if  a  colour  allocation
     fails.  The -colours argument shows how these are allocated,
     and -help -colours can be used to get  the  colour  resource
     names.

OPTIONS
     Xmred accepts the standard X Toolkit  options,  as  well  as
     these.

     -help
          Lists the command options, application resource  fields
          and  some  other  information to stderr. Does not start
          the game. If the -colours option is supplied too,  then
          the  colour  resource  classes are listed instead, with
          their default values. The format of this list is  suit-
          able  for inclusion in a resource file. Note, this does
          not list out the colour values that you  would  get  if
          you  ran  the  game,  as  it  does  not  read the color



X Version 11                                                    3






XMRED(6)                 GAMES AND DEMOS         20 December 1993



          resources.

     -swap
     -rv
     -reverse
          Normally the foreground is  black  and  the  background
          white,  this  swaps them round. On colour systems, this
          may also alter other colours.

     +swap
     -noswap
          Override a swap resource in your  resources,  to  force
          unswapped colours.

     -mono
          Use black and white, even on colour  displays.  (Unfor-
          tunately,  the obvious option, '-bw', is already nabbed
          by the toolkit as borderwidth.)

     -mris
     -msit
     -gender _g_e_n_d_e_r
          Xmred has two sets of sprites. Mris selects the classic
          sprites,  while  msit  selects a more modern set. Valid
          genders are  'he',  'she',  'female',  'male',  'msit',
          'mris', 'boy', 'girl'.

     -depth _d_e_p_t_h
          Xmred will use the default depth of the screen. You may
          wish to override that by using this option. Selecting a
          different depth may affect the visual selected.

     -visual _v_i_s_u_a_l-_c_l_a_s_s
          Xmred will pick the default visual, but you  can  over-
          ride  that  by  specifying  a  particular visual class.
          Valid   visuals   are   'PseudoColor',   'DirectColor',
          'TrueColor',   'StaticColor',  'GrayScale',  and  'Sta-
          ticGray'. To see which one is picked, you can  use  the
          -colours option. If you do select a non-default visual,
          you may have to specify a private colour map  too,  due
          to limitations of the server or display.

     -private
          This forces xmred to allocate  a  private  colour  map.
          Normally xmred will share the default colour map of the
          selected visual, but if that does not have enough  free
          colour cells then some colours will have to be shared.

     -colours
     -colors
          Show how the colours are allocated,  and  which  visual
          has been selected.  The allocation is listed to stdout.



X Version 11                                                    4






XMRED(6)                 GAMES AND DEMOS         20 December 1993



          When allocating each colour, its resource name and  rgb
          values  are  listed  together  with the nearest already
          allocated colour  and  the  distance  between  them  in
          colour  space.  The  allocated  pixel number is printed
          last. If  given  with  the  -help  option,  the  colour
          resource  classes  are  listed,  and  the game does not
          start.

     -distinct _n
          Sets the number of distinct colours used. This  can  be
          used  to  limit  the  number  of  colours used from the
          colour map. Black and white are not included, and  nei-
          ther  are  the two writable colours used for the garden
          backgrounds on dynamic visuals. Note that  -distinct  0
          is different from -mono, even though both will only use
          black and white.

RESOURCES
     Xmred uses the X toolkit application resource mechanism  for
     setting up the environment. Application resource items start
     with 'Xmris', so that xmred will pick up your  defaults  for
     xmris.  The  resource  name  can  be  derived from the given
     resource class by decapitalizing it. For  example  'cherryS-
     talk'  is the resource name for the class 'cherryStalk'. The
     following classes are used (choices in '{}' and defaults  in
     '[]'.)

     Xmris.ReverseVideo: {_y_e_s, _n_o} [no]
          Specifies whether to use swapped colours or not.

     Xmris.Mono: {_y_e_s, _n_o} [no]
          Whether  the  default  is  for  monochrome  on   colour
          displays.

     Xmris.Gender: _g_e_n_d_e_r [he]
          Sets the default game gender. Valid genders are 'mris',
          'msit', 'she', 'he', 'female', 'male', 'boy', 'girl'.

     Xmris.Depth: _d_e_p_t_h
          Set the required screen depth to use.

     Xmris.Visual: _v_i_s_u_a_l-_c_l_a_s_s
          Set the required visual class to use. Valid visuals are
          'PseudoColor',    'DirectColor',   'TrueColor',   'Sta-
          ticColor', 'GrayScale', and 'StaticGray'.

     Xmris.Private: {_y_e_s, _n_o} [no]
          Set whether or not to use a private colour map.

     Xmris.Distinct: _n
          Set the number of distinct colours allocated  from  the
          colour map.



X Version 11                                                    5






XMRED(6)                 GAMES AND DEMOS         20 December 1993



     In addition, you have the normal resources such as '*Font'.

COLOUR RESOURCES
     There are many colour name defaults. For a full  description
     see  the  xmris(6)  manual  page,  but note that not all the
     colors are used for xmred. Provided that you  specified  the
     colour  resources  for xmris loosely enough, xmred will pick
     up the same overrides. The foreground  color  for  the  Icon
     widgets  is copied from the apple faint color on color visu-
     als (this is important for the noswap color scheme).

WIDGET RESOURCES
     There are a few resources which are picked up  from  widgets
     within  the  widget  tree. They are the initial button bind-
     ings, colors, fills and mode.  The bindings are attached  to
     the  individual  button  displays.  The options are 'apple',
     'random', 'cherry', 'path', 'player' and 'den'. The  colors,
     fills and mode are attached to the color, fill and mode form
     widgets. The value must be an integer in the correct range.

     There is an additional composite resource  for  children  of
     composite  widgets  (Paned and SimpleMenu), called 'attach'.
     This allows you to change the ordering of  sibling  widgets.
     Xmred  uses  this resource to determine the correct order to
     create the sibling widgets. For instance, to get the control
     panel  on  the left of the garden widget, use the constraint
     '*one.garden.attach:panel'.  In addition,  the  widgets  are
     created  in  such an order that Form constraints 'fromHoriz'
     and 'fromVert' can be specified in any order.

     There are four new widgets used for xmred,  'Icon',  'Drag',
     'Garden' and 'PixmapList'.

     The Icon widget is a subclass of Simple. It displays a  pix-
     map  and  allows  its  selection with any button press. If a
     button is dragged on it, it may invoke a drag widget to per-
     form  a  drag operation.  It has the following new resources
     of interest.

     dragSensitivity: _p_i_x_e_l_s [4]
          Sets the minimum drag which must occur, before  a  drag
          widget  is  popped  up, to take over the dragging. When
          set to zero, dragging is disabled.

     flashDelay: _d_e_l_a_y [100]
          Sets the time for which the  widget  is  highlit  after
          selection. This time is in milliseconds.

     highlightThickness: _p_i_x_e_l_s [1]
          Sets the thickness of the highlight box.





X Version 11                                                    6






XMRED(6)                 GAMES AND DEMOS         20 December 1993



     foreground: _c_o_l_o_r [default foreground]
          Sets the color of the highlight box and block.

     The Drag widget is a subclass of OverrideShell. It  displays
     a  pixmap,  and  follows  the  pointer  until  a  button  is
     released. Its use is for drag and drop. It has no additional
     resources of user interest.

     The Garden widget is a subclass of Simple. It  performs  the
     garden  editing.   It  has  no  additional resources of user
     interest.

     The PixmapList widget is a subclass of Simple. It displays a
     list  of pixmaps, and permits them to be scrolled. Each pix-
     map may be selected by a button  press  on  it,  or  a  drag
     widget  invoked by dragging on a pixmap.  In addition to the
     Icon widget additional resources, it has the following addi-
     tional resources of user interest.

     distance: _p_i_x_e_l_s [4]
          The distance between each pixmap.

     pixmapBorderWidth: _p_i_x_e_l_s [1]
          The border width for each pixmap.

     pixmapBorderColor: _c_o_l_o_r [default foreground]
          The border color for each pixmap.

ENVIRONMENT
     A few environment variables are used to locate resources.

     DISPLAY
         The default display to connect  to.  May  be  overridden
         with the -display option.

FILES
     ~/.Xdefaults
     .../app-defaults/Xmris.ad
     .../app-defaults/Xmris-color.ad
          You can place you favourite key bindings and  stuff  in
          an  application resource file, and xmred will use them,
          rather than its compiled defaults.  See X for  informa-
          tion about how these are searched.

     .../app-defaults/xmris/<gardens>
          Search path for loadable gardens used by xmris.

SEE ALSO
     xmris(6)

ERRORS




X Version 11                                                    7






XMRED(6)                 GAMES AND DEMOS         20 December 1993



     If  a  loaded  garden  is  incorrect,  an  error  dialog  is
     displayed,  enabling  you to locate the offending garden and
     lines.

BUGS
     The visual class name conversion is performed by a  standard
     toolkit  routine.  It  accepts  only  American spelling, the
     English spelling of

     The Drag widget should perhaps just be  a  shell,  having  a
     single child of Icon, to do the rendering.

     The PixmapList widget should perhaps be a  composite  widget
     with  Icon  children.  However when I tried this using a Box
     widget, it didn't work with the insert function.

COPYRIGHT
     Copyright (C) 1993 Nathan Sidwell.

AUTHOR
     Nathan Sidwell <nathan@pact.srf.ac.uk>

     Additional sprites by Stefan Gustavson <stefang@isy.liu.se>
































X Version 11                                                    8



